/**
 * Ext GWT 3.0.0-beta2 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.box;

import com.sencha.gxt.widget.core.client.ComponentHelper;
import com.sencha.gxt.widget.core.client.form.Field;

public abstract class AbstractInputMessageBox extends MessageBox {

  protected Field<String> field;

  protected AbstractInputMessageBox(Field<String> field, String title, String message) {
    super(title, message);
    
    ComponentHelper.setParent(this, field);

    this.field = field;
    setFocusWidget(field);

    contentAppearance.getContentElement(getElement()).appendChild(field.getElement());
    setPredefinedButtons(PredefinedButton.OK, PredefinedButton.CANCEL);
  }

  public String getValue() {
    return field.getValue();
  }

  public Field<String> getField() {
    return field;
  }

  @Override
  protected void doAttachChildren() {
    super.doAttachChildren();
    ComponentHelper.doAttach(field);
  }

  @Override
  protected void doDetachChildren() {
    super.doDetachChildren();
    ComponentHelper.doDetach(field);
  }

  @Override
  protected void onResize(int width, int height) {
    super.onResize(width, height);
    field.setWidth(getContainerTarget().getWidth(true));
  }

}
