/**
 * Ext GWT 3.0.0-beta2 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.button;

import com.google.gwt.resources.client.ImageResource;
import com.sencha.gxt.cell.core.client.TextButtonCell;
import com.sencha.gxt.widget.core.client.event.SelectEvent.SelectHandler;

public class TextButton extends CellButtonBase<String> {

  protected TextButtonCell cell;

  public TextButton() {
    this(new TextButtonCell());
  }

  public TextButton(String text) {
    this(new TextButtonCell(), text);
  }
  
  public TextButton(TextButtonCell cell, String text) {
    super(cell, text);
    setText(text);
  }

  public TextButton(String text, SelectHandler handler) {
    this(text);
    addSelectHandler(handler);
  }

  public TextButton(String text, ImageResource icon) {
    this(text);
    setIcon(icon);
  }

  public TextButton(TextButtonCell cell) {
    super(cell, null);
    this.cell = cell;
  }

}
