/**
 * Ext GWT 3.0.0-beta2 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.form;

import java.util.ArrayList;
import java.util.List;

import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Element;
import com.google.gwt.event.dom.client.ChangeEvent;
import com.google.gwt.event.dom.client.ChangeHandler;
import com.google.gwt.event.logical.shared.ValueChangeEvent;
import com.google.gwt.event.logical.shared.ValueChangeHandler;
import com.google.gwt.resources.client.ImageResource;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.RichTextArea;
import com.google.gwt.user.client.ui.RichTextArea.FontSize;
import com.google.gwt.user.client.ui.RichTextArea.Justification;
import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.messages.client.DefaultMessages;
import com.sencha.gxt.widget.core.client.Component;
import com.sencha.gxt.widget.core.client.button.TextButton;
import com.sencha.gxt.widget.core.client.button.ToggleButton;
import com.sencha.gxt.widget.core.client.container.VerticalLayoutContainer;
import com.sencha.gxt.widget.core.client.container.VerticalLayoutContainer.VerticalLayoutData;
import com.sencha.gxt.widget.core.client.event.SelectEvent;
import com.sencha.gxt.widget.core.client.event.SelectEvent.SelectHandler;
import com.sencha.gxt.widget.core.client.menu.ColorMenu;
import com.sencha.gxt.widget.core.client.tips.ToolTipConfig;
import com.sencha.gxt.widget.core.client.toolbar.SeparatorToolItem;
import com.sencha.gxt.widget.core.client.toolbar.ToolBar;

public class HtmlEditor extends AdapterField<String> {

  public interface HtmlEditorAppearance {

    ImageResource bold();

    String editor();

    ImageResource fontColor();

    ImageResource fontDecrease();

    ImageResource fontHighlight();

    ImageResource fontIncrease();

    String frame();

    Element getContentElement(XElement parent);

    ImageResource italic();

    ImageResource justifyCenter();

    ImageResource justifyLeft();

    ImageResource justifyRight();

    ImageResource link();

    ImageResource ol();

    ImageResource source();

    ImageResource ul();

    ImageResource underline();
  }

  public interface HtmlEditorMessages {
    String backColorTipText();

    String backColorTipTitle();

    String boldTipText();

    String boldTipTitle();

    String createLinkText();

    String decreaseFontSizeTipText();

    String decreaseFontSizeTipTitle();

    String foreColorTipText();

    String foreColorTipTitle();

    String increaseFontSizeTipText();

    String increateFontSizeTipTitle();

    String italicTipText();

    String italicTipTitle();

    String justifyCenterTipText();

    String justifyCenterTipTitle();

    String justifyLeftTipText();

    String justifyLeftTipTitle();

    String justifyRightTipText();

    String justifyRightTipTitle();

    String linkTipText();

    String linkTipTitle();

    String olTipText();

    String olTipTitle();

    String sourceEditTipText();

    String sourceEditTipTitle();

    String ulTipText();

    String ulTipTitle();

    String underlineTipText();

    String underlineTipTitle();
  }

  protected class HtmlEditorDefaultMessages implements HtmlEditorMessages {

    @Override
    public String backColorTipText() {
      return DefaultMessages.getMessages().htmlEditor_backColorTipText();
    }

    @Override
    public String backColorTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_backColorTipTitle();
    }

    @Override
    public String boldTipText() {
      return DefaultMessages.getMessages().htmlEditor_boldTipText();
    }

    @Override
    public String boldTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_boldTipTitle();
    }

    @Override
    public String createLinkText() {
      return DefaultMessages.getMessages().htmlEditor_createLinkText();
    }

    @Override
    public String decreaseFontSizeTipText() {
      return DefaultMessages.getMessages().htmlEditor_decreaseFontSizeTipText();
    }

    @Override
    public String decreaseFontSizeTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_decreaseFontSizeTipTitle();
    }

    @Override
    public String foreColorTipText() {
      return DefaultMessages.getMessages().htmlEditor_foreColorTipText();
    }

    @Override
    public String foreColorTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_foreColorTipTitle();
    }

    @Override
    public String increaseFontSizeTipText() {
      return DefaultMessages.getMessages().htmlEditor_increaseFontSizeTipText();
    }

    @Override
    public String increateFontSizeTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_increaseFontSizeTipTitle();
    }

    @Override
    public String italicTipText() {
      return DefaultMessages.getMessages().htmlEditor_italicTipText();
    }

    @Override
    public String italicTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_italicTipTitle();
    }

    @Override
    public String justifyCenterTipText() {
      return DefaultMessages.getMessages().htmlEditor_justifyCenterTipText();
    }

    @Override
    public String justifyCenterTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_justifyCenterTipTitle();
    }

    @Override
    public String justifyLeftTipText() {
      return DefaultMessages.getMessages().htmlEditor_justifyLeftTipText();
    }

    @Override
    public String justifyLeftTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_justifyLeftTipTitle();
    }

    @Override
    public String justifyRightTipText() {
      return DefaultMessages.getMessages().htmlEditor_justifyRightTipText();
    }

    @Override
    public String justifyRightTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_justifyRightTipTitle();
    }

    @Override
    public String linkTipText() {
      return DefaultMessages.getMessages().htmlEditor_linkTipText();
    }

    @Override
    public String linkTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_linkTipTitle();
    }

    @Override
    public String olTipText() {
      return DefaultMessages.getMessages().htmlEditor_olTipText();
    }

    @Override
    public String olTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_olTipTitle();
    }

    @Override
    public String sourceEditTipText() {
      return DefaultMessages.getMessages().htmlEditor_sourceEditTipText();
    }

    @Override
    public String sourceEditTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_sourceEditTipTitle();
    }

    @Override
    public String ulTipText() {
      return DefaultMessages.getMessages().htmlEditor_ulTipText();
    }

    @Override
    public String ulTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_ulTipTitle();
    }

    @Override
    public String underlineTipText() {
      return DefaultMessages.getMessages().htmlEditor_underlineTipText();
    }

    @Override
    public String underlineTipTitle() {
      return DefaultMessages.getMessages().htmlEditor_underlineTipTitle();
    }

  }

  protected VerticalLayoutContainer container;
  protected ToolBar toolBar;
  protected final HtmlEditorAppearance appearance;
  protected HtmlEditorMessages messages;
  protected RichTextArea textArea;
  protected TextArea sourceTextArea;
  protected List<FontSize> fontSizesConstants = new ArrayList<FontSize>();
  protected FontSize activeFontSize = FontSize.SMALL;

  private boolean enableAlignments = true;
  private boolean enableColors = true;
  private boolean enableFont = true;
  private boolean enableFontSize = true;
  private boolean enableFormat = true;
  private boolean enableLinks = true;
  private boolean enableLists = true;
  private boolean showToolbar = true;
  private boolean sourceEditMode = true;
  private TextButton fontIncrease;
  private TextButton fontDecrease;
  private SelectHandler buttonHandler;
  private ToggleButton bold;
  private ToggleButton italic;
  private ToggleButton underline;
  private TextButton justifyLeft;
  private TextButton justifyCenter;
  private TextButton justifyRight;
  private TextButton ol;
  private TextButton ul;
  private TextButton link;
  private TextButton fontColor;
  private TextButton fontHighlight;
  private ToggleButton sourceEdit;

  public HtmlEditor() {
    this(GWT.<HtmlEditorAppearance> create(HtmlEditorAppearance.class));
  }

  public HtmlEditor(HtmlEditorAppearance appearance) {
    super(new VerticalLayoutContainer());
    this.container = (VerticalLayoutContainer) getWidget();
    this.appearance = appearance;

    addStyleName(appearance.editor());
    setBorders(true);

    toolBar = new ToolBar();

    textArea = new RichTextArea();
    textArea.addStyleName(appearance.frame());

    container.add(toolBar, new VerticalLayoutData(1, -1));
    container.add(textArea, new VerticalLayoutData(1, 1));

    fontSizesConstants.add(FontSize.XX_SMALL);
    fontSizesConstants.add(FontSize.X_SMALL);
    fontSizesConstants.add(FontSize.SMALL);
    fontSizesConstants.add(FontSize.MEDIUM);
    fontSizesConstants.add(FontSize.LARGE);
    fontSizesConstants.add(FontSize.X_LARGE);
    fontSizesConstants.add(FontSize.XX_LARGE);
  }

  public HtmlEditorMessages getMessages() {
    if (messages == null) {
      messages = new HtmlEditorDefaultMessages();
    }
    return messages;
  }

  @Override
  public String getValue() {
    return textArea.getHTML();
  }

  public boolean isEnableAlignments() {
    return enableAlignments;
  }

  public boolean isEnableColors() {
    return enableColors;
  }

  public boolean isEnableFont() {
    return enableFont;
  }

  public boolean isEnableFontSize() {
    return enableFontSize;
  }

  public boolean isEnableFormat() {
    return enableFormat;
  }

  public boolean isEnableLinks() {
    return enableLinks;
  }

  public boolean isEnableLists() {
    return enableLists;
  }

  public boolean isShowToolbar() {
    return showToolbar;
  }

  public boolean isSourceEditMode() {
    return sourceEditMode;
  }

  public void pushValue() {
    textArea.setHTML(sourceTextArea.getValue());
  }

  public void setEnableAlignments(boolean enableAlignments) {
    this.enableAlignments = enableAlignments;
  }

  public void setEnableColors(boolean enableColors) {
    this.enableColors = enableColors;
  }

  public void setEnableFont(boolean enableFont) {
    this.enableFont = enableFont;
  }

  public void setEnableFontSize(boolean enableFontSize) {
    this.enableFontSize = enableFontSize;
  }

  public void setEnableFormat(boolean enableFormat) {
    this.enableFormat = enableFormat;
  }

  public void setEnableLinks(boolean enableLinks) {
    this.enableLinks = enableLinks;
  }

  public void setEnableLists(boolean enableLists) {
    this.enableLists = enableLists;
  }

  public void setMessages(HtmlEditorMessages messages) {
    this.messages = messages;
  }

  @Override
  public void setValue(String value) {
    textArea.setHTML(value);
  }

  public void syncValue() {
    sourceTextArea.setValue(getValue());
  }

  protected void initToolBar() {
    if (!showToolbar) {
      return;
    }

    buttonHandler = new SelectHandler() {

      @Override
      public void onSelect(SelectEvent event) {
        Widget button = (Widget) event.getSource();

        if (button == fontIncrease) {
          int i = fontSizesConstants.indexOf(activeFontSize);
          if (i > 0) {
            i--;
            activeFontSize = fontSizesConstants.get(i);
            textArea.getFormatter().setFontSize(activeFontSize);
          } else {
            // brings focus back to the editor
            focus();
          }
        } else if (button == fontDecrease) {
          int i = fontSizesConstants.indexOf(activeFontSize);
          if (i > 0) {
            i--;
            activeFontSize = fontSizesConstants.get(i);
            textArea.getFormatter().setFontSize(activeFontSize);
          } else {
            // brings focus back to the editor
            focus();
          }
        } else if (button == bold) {
          textArea.getFormatter().toggleBold();
        } else if (button == italic) {
          textArea.getFormatter().toggleItalic();
        } else if (button == underline) {
          textArea.getFormatter().toggleUnderline();
        } else if (button == justifyLeft) {
          textArea.getFormatter().setJustification(Justification.LEFT);
        } else if (button == justifyCenter) {
          textArea.getFormatter().setJustification(Justification.CENTER);
        } else if (button == justifyRight) {
          textArea.getFormatter().setJustification(Justification.RIGHT);
        } else if (button == ol) {
          textArea.getFormatter().insertOrderedList();
        } else if (button == ul) {
          textArea.getFormatter().insertUnorderedList();
        } else if (button == link) {
          String link = Window.prompt(getMessages().createLinkText(), "http://");
          if (link != null && link.length() > 0) {
            textArea.getFormatter().createLink(link);
          } else {
            textArea.getFormatter().removeLink();
          }
        }
      }
    };
    
    HtmlEditorMessages m = getMessages();

    if (sourceEditMode) {
      sourceEdit = new ToggleButton();
      sourceEdit.setIcon(appearance.source());
      sourceEdit.setToolTipConfig(createTipConfig(m.sourceEditTipTitle(), m.sourceEditTipText()));
      sourceEdit.addSelectHandler(new SelectHandler() {
        @Override
        public void onSelect(SelectEvent event) {
          toggleSourceEditMode();
          focus();
        }
      });
      toolBar.add(sourceEdit);
      toolBar.add(new SeparatorToolItem());
    }

    if (enableFont) {
      final ListBox fonts = new ListBox();
      fonts.addItem("");
      fonts.addItem("Arial");
      fonts.addItem("Times New Roman");
      fonts.addItem("Verdana");
      fonts.setItemSelected(0, true);
      fonts.addChangeHandler(new ChangeHandler() {

        public void onChange(ChangeEvent event) {
          int index = fonts.getSelectedIndex();
          if (index != 0) {
            textArea.getFormatter().setFontName(fonts.getItemText(index));
          }
          fonts.setItemSelected(0, true);
        }
      });
      toolBar.add(fonts);
      toolBar.add(new SeparatorToolItem());
    }

    if (enableFontSize) {
      fontIncrease = new TextButton();
      fontIncrease.setIcon(appearance.fontIncrease());
      fontIncrease.setToolTipConfig(createTipConfig(m.increateFontSizeTipTitle(), m.increaseFontSizeTipText()));
      fontIncrease.addSelectHandler(buttonHandler);
      toolBar.add(fontIncrease);

      fontDecrease = new TextButton();
      fontDecrease.setIcon(appearance.fontDecrease());
      fontDecrease.setToolTipConfig(createTipConfig(m.decreaseFontSizeTipTitle(), m.decreaseFontSizeTipText()));
      fontDecrease.addSelectHandler(buttonHandler);
      toolBar.add(fontDecrease);

      toolBar.add(new SeparatorToolItem());
    }

    if (enableFormat) {
      bold = new ToggleButton();
      bold.setIcon(appearance.bold());
      bold.setToolTipConfig(createTipConfig(m.boldTipTitle(), m.boldTipText()));
      bold.addSelectHandler(buttonHandler);
      toolBar.add(bold);

      italic = new ToggleButton();
      italic.setIcon(appearance.italic());
      bold.setToolTipConfig(createTipConfig(m.italicTipTitle(), m.italicTipText()));
      italic.addSelectHandler(buttonHandler);
      toolBar.add(italic);

      underline = new ToggleButton();
      underline.setIcon(appearance.underline());
      underline.setToolTipConfig(createTipConfig(m.underlineTipTitle(), m.underlineTipText()));
      underline.addSelectHandler(buttonHandler);
      toolBar.add(underline);

      toolBar.add(new SeparatorToolItem());
    }

    if (enableAlignments) {
      justifyLeft = new TextButton();
      justifyLeft.setIcon(appearance.justifyLeft());
      justifyLeft.setToolTipConfig(createTipConfig(m.justifyLeftTipTitle(), m.justifyLeftTipText()));
      justifyLeft.addSelectHandler(buttonHandler);
      toolBar.add(justifyLeft);

      justifyCenter = new TextButton();
      justifyCenter.setIcon(appearance.justifyCenter());
      justifyLeft.setToolTipConfig(createTipConfig(m.justifyCenterTipTitle(), m.justifyCenterTipText()));
      justifyCenter.addSelectHandler(buttonHandler);
      toolBar.add(justifyCenter);

      justifyRight = new TextButton();
      justifyRight.setIcon(appearance.justifyRight());
      justifyLeft.setToolTipConfig(createTipConfig(m.justifyRightTipTitle(), m.justifyRightTipText()));
      justifyRight.addSelectHandler(buttonHandler);
      toolBar.add(justifyRight);

      toolBar.add(new SeparatorToolItem());
    }

    if (enableLists) {
      ol = new TextButton();
      ol.setIcon(appearance.ol());
      ol.setToolTipConfig(createTipConfig(m.olTipTitle(), m.olTipText()));
      ol.addSelectHandler(buttonHandler);
      toolBar.add(ol);

      ul = new TextButton();
      ul.setIcon(appearance.ul());
      ul.setToolTipConfig(createTipConfig(m.ulTipTitle(), m.ulTipText()));
      ul.addSelectHandler(buttonHandler);
      toolBar.add(ul);

      toolBar.add(new SeparatorToolItem());
    }

    if (enableLinks) {
      link = new TextButton();
      link.setIcon(appearance.link());
      link.setToolTipConfig(createTipConfig(m.linkTipTitle(), m.linkTipText()));
      link.addSelectHandler(buttonHandler);
      toolBar.add(link);

      toolBar.add(new SeparatorToolItem());
    }

    if (enableColors) {
      fontColor = new TextButton();
      fontColor.setIcon(appearance.fontColor());
      fontColor.setToolTipConfig(createTipConfig(m.foreColorTipTitle(), m.foreColorTipText()));
      ColorMenu menu = new ColorMenu();
      menu.getPalette().addValueChangeHandler(new ValueChangeHandler<String>() {

        @Override
        public void onValueChange(ValueChangeEvent<String> event) {
          textArea.getFormatter().setForeColor(event.getValue());
        }
      });
      fontColor.setMenu(menu);

      toolBar.add(fontColor);

      fontHighlight = new TextButton();
      fontHighlight.setIcon(appearance.fontHighlight());
      fontHighlight.setToolTipConfig(createTipConfig(m.backColorTipTitle(), m.backColorTipText()));
      
      menu = new ColorMenu();
      menu.getPalette().addValueChangeHandler(new ValueChangeHandler<String>() {
        @Override
        public void onValueChange(ValueChangeEvent<String> event) {
          textArea.getFormatter().setBackColor(event.getValue());
        }
      });
      fontHighlight.setMenu(menu);

      toolBar.add(fontHighlight);
    }
  }
  
  @Override
  protected void onAfterFirstAttach() {
    super.onAfterFirstAttach();
    initToolBar();
  }

  protected void toggleSourceEditMode() {
    if (sourceEdit.getValue()) {
      if (sourceTextArea == null) {
        sourceTextArea = new TextArea();
      }

      syncValue();
      container.remove(1);
      container.add(sourceTextArea, new VerticalLayoutData(1, 1));
      container.forceLayout();
    } else {
      pushValue();
      container.remove(1);
      container.add(textArea, new VerticalLayoutData(1, 1));
      container.forceLayout();
    }

    for (int i = 0; i < toolBar.getWidgetCount(); i++) {
      Widget w = toolBar.getWidget(i);
      if (w != sourceEdit && w instanceof Component) {
        ((Component) w).setEnabled(!sourceEdit.getValue());
      }
    }
  }

  private ToolTipConfig createTipConfig(String title, String text) {
    return new ToolTipConfig(title, text);
  }

}
